from cocos.layer.base_layers import *
import cocos
import pyglet
import gameplay
from ccreader import *
from cocos.scenes import *
import main

def CreateScene(game_values):
    cr = CreatorReader()
    scene = cr.LoadScene("Scene/gameover.ccreator")
    scene.add(GameOverScreen(game_values, scene))
    return scene

class GameOverScreen(Layer):
    is_event_handler = True
    def __init__(self, game_values, scene):
        super(GameOverScreen,self).__init__()
        self.game_values = game_values
        scene.add(self)
        self.icon = scene.node_dict["icon"][0]
        self.text = scene.node_dict["statement"][0]
        self.scene_done = False
        self.scene = scene
        self.init_view()

    def on_key_release (self, key, modifiers):        
        if self.scene_done:
            return
        self.scene_done = True
        self.start_gameplay()

    def on_mouse_press(self, x, y, d, f):
        if self.scene_done:
            return
        self.scene_done = True
        self.start_gameplay()

    def start_gameplay(self):
        #move to main screen.
        scn = main.CreateScene()
        cocos.director.director.replace(SlideInLTransition(scn, duration=0.5))

    def init_view(self):
        image = None
        str_text = "You have successfully completed pyweek!"
        if self.game_values[0] <= 0:
            image = pyglet.resource.image("Texture/social.png")
            self.icon.color = (255, 0, 0)
            str_text = "You become too lonely and are unable to go on.. "
            #social failure
        elif self.game_values[0] >= gameplay.GamePlay.MAX_VALUE:
            image = pyglet.resource.image("Texture/social.png")
            #social overwhelm
            str_text = "You are a social butterfly, pyweek isn't that important."
        elif self.game_values[1] <= 0:
            #game failure
            image = pyglet.resource.image("Texture/game.png")
            self.icon.color = (255, 0, 0)
            str_text = "You lack the motivation / decipline to finish your game."
        elif self.game_values[1] >= gameplay.GamePlay.MAX_VALUE:
            #game finish successful pyweek
            image = pyglet.resource.image("Texture/game.png")
            str_text = "You have managed to finish this pyweek with a game."
        elif self.game_values[2] <= 0:
            #money failure.
            self.icon.color = (255, 0, 0)
            image = pyglet.resource.image("Texture/money.png")
            str_text = "You are too broke to continue, you need to make some money."
        elif self.game_values[2] >= gameplay.GamePlay.MAX_VALUE:
            #money success
            image = pyglet.resource.image("Texture/money.png")
            str_text = "The money is too good, pyweek can wait."
        
        self.icon.image = image
        self.text.element.text = str_text