from ccreader import *
import cocos
from cocos.layer.base_layers import *
from cocos.actions.interval_actions import *
from opencard import *
from cocos.scenes import *
import math
import questions
import gameover

class GamePlay(Layer):
    is_event_handler = True
    TIME_TEXT = "TimeIndicator"
    MAX_VALUE = 20.0
    def __init__(self, scene):
        super(GamePlay, self).__init__()
        self.scene = scene
        self.posx = 100
        self.posy = 240
        self.text = cocos.text.Label('No mouse events yet', font_size=18, x=self.posx, y=self.posy )

        self.game_hours = 0
        # self.add( self.text )
        ql = questions.Load()
        self.cql = ql
        #set the rotation at the bottom of the card. 
        self.open_card = OpenCard(self)
        # self.oc_option_text.opacity = 0
        self.game_values = [5, 5, 5]
        self.value_labels = self.get_nodes("ValueLabel")
        for lbl in self.value_labels:
            lbl.element.anchor_x = "left"
        self.update_value_labels()


    def update_value_labels(self):
        for i, lbl in enumerate(self.value_labels):
            lbl.element.text = str((self.game_values[i]/self.MAX_VALUE) * 100.0) + "%"

    def get_question(self):
        return self.cql[0] 

    def handle_gameover(self):
        #switch scene to the game over one.
        go_scene = gameover.CreateScene(self.game_values)
        cocos.director.director.replace(SlideInRTransition(go_scene, duration=0.5))
        
    def player_choice(self, yes):
        q = self.cql[0]
        opt = None
        try: 
            opt = q[questions.OPTIONS_KEY][yes]
        except:
            opt = q[questions.OPTIONS_KEY][0]       
                
        #update the time on game. 
        self.game_hours +=  q[questions.TIME_KEY]
        self.get_node(self.TIME_TEXT).element.text = str(self.game_hours) + " H"
        values = opt[questions.VALUES_KEY]
        game_over = False
        for i,value in enumerate(values):
            self.game_values[i] += value
            self.value_labels[i].element.text = str((self.game_values[i]/self.MAX_VALUE) * 100.0) + "%"
            if self.game_values[i] <= 0 or self.game_values[i] >= self.MAX_VALUE:
                game_over = True

        if game_over:
            self.handle_gameover()
            return
        try:
            self.cql = opt[questions.OPTION_QUESTIONS_KEY] + self.cql[1:]
        except:
            self.cql = self.cql[1:]

        if yes: #swipe right
            pass
        else: #swipe left
            pass

    def update_text(self, x, y):
        text = 'Mouse @ %d,%d' % (x, y)
        self.text.element.text = text
        self.text.element.x = self.posx
        self.text.element.y = self.posy

    def on_mouse_motion(self, x, y, dx, dy):
        # self.update_text (x, y)
        self.open_card.on_mouse_motion(x, y, dx, dy)
    
    def on_mouse_press(self, x, y, buttons, modifiers):
        self.open_card.on_mouse_press(x, y, buttons, modifiers)
    
    def get_node(self, node_name):
        if node_name in self.scene.node_dict:
            return self.scene.node_dict[node_name][0]
    def get_nodes(self, node_name):
        if node_name in self.scene.node_dict:
            return self.scene.node_dict[node_name]

def CreateGameScene():
    cr = CreatorReader()
    scene = cr.LoadScene("Scene/gameplay.ccreator")
    # scene = cocos.scene.Scene(GamePlay())
    scene.add(GamePlay(scene))
    return scene