'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "gamelib"
package.
'''

import pyglet
import cocos
from cocos.layer.base_layers import *
import gameplay
from ccreader import *
from cocos.scenes import *

class MainScreen(Layer):
    is_event_handler = True

    def __init__(self, scene):
        super(MainScreen, self).__init__()
        scene.add(self)
        self.scene_done = False

    def on_key_release (self, key, modifiers):        
        if self.scene_done:
            return
        self.scene_done = True
        self.start_gameplay()

    def on_mouse_press(self, x, y, d, f):
        if self.scene_done:
            return
        self.scene_done = True
        self.start_gameplay()
    
    def start_gameplay(self):
        scn = gameplay.CreateGameScene()
        cocos.director.director.replace(SlideInRTransition(scn, duration=0.5))
        #cocos.director.director.run(scn)

def CreateScene():
    cr = CreatorReader()
    scene = cr.LoadScene("Scene/home.ccreator")
    scene.add(MainScreen(scene))
    return scene

def main():
    print "Hello from your game's main()"
    pyglet.resource.path.append("Resources/")
    pyglet.resource.reindex()

    cocos.director.director.init(960, 640)
    scn = CreateScene() #gameplay.CreateGameScene()
    cocos.director.director.run(scn)
    

