import json
import pyglet

QUESTION_KEY = "q"
CHARACTER_KEY = "c"
OPTIONS_KEY = "o" #(-ve, +ve)
VALUES_KEY = "v" #(social, game, money, time in hours)
OPTION_QUESTIONS_KEY = "ql"
TIME_KEY = "t"

"""
Question json structure. 
{
    "q": "This is the question text",
    "c": "Name",
    "t": 0,
    "o": [{    "v": [sv, gv, dv], "o": "opt1", "ql": []}, {    "v": [sv, gv, dv], "o": "opt2", "ql":[]}]
}

{
    "c": "",
    "q": "",                        
    "t": 0,
    "o": [{"v": [0, 0, 0],"o": "opt1", "ql": []}, {"v": [0, 0, 0],"o": "opt2", "ql":[]}]
}

Each option provided has question list associated with it, this can be empty or the new list of questions to be asked. 
There might be only one option, we have to handle in the UI to show that on both left and right.

We will have initial stack of questions picked, based on the previous plays.. we will add questions to the stack based on choices.
"""

def Load():
    fp = pyglet.resource.file("questions/questions.json")
    q_list = json.load(fp)
    # print q_list
    return q_list